
-- (c) MP-I and CP (1998/99-2007/08)

module SMT where

import Cp
import St

data SMT s m a = SMT { smt :: (s -> m(a, s)) }
-- NB: St s corresponds to SMT s m for m the identity monad

instance (Monad m, Functor m) => Monad (SMT s m) where
	return = SMT . (curry return)
-- PW:  return a = SMT (return . (split (const a) id))
	x       >>= f = (SMT . fmap (mult. fmap (uncurry (smt . f))) . smt) x
-- PW:  (SMT g) >>= f = SMT (\s -> do { (a,s') <- g s ; let SMT k = f a in  k s' })

-- inject ST into SMT, also called the "insert" operator

iSt :: (Monad m) => St s a -> SMT s m a 
iSt = SMT . (expn return) . st
--  = SMT . (return .) . st

-- inject M into SMT, also called the "lift" operation

iM :: (Monad m) => m a -> SMT s m a
iM x = SMT(\s -> do { a <- x ; return (a,s) })

instance (Functor m, Monad m, Strong m) => MT (SMT s) m where
	lift = iM
       
-- extract M from SMT, related to the "unlift" operation

xM :: (Monad m,Functor m) => SMT s m a -> s -> m a
xM x = fmap p1 . (smt x)

-- that is: xM x s = do { (a,_) <- smt x s ; return a }

runSMT :: (Monad m, Functor m) => SMT s m a -> s -> m a
runSMT x s  = (xM x) s

